import datetime
import time

class Job():
    def __init__(self, pid, cpu_req, status):
        self._pid = pid
        self._cpucycle = cpu_req
        self._status = status
    
    def __str__(self):
        return f'pid: {self._pid} | size: {self._cpucycle} | status: {self._status}'

class Scheduler():
    def __init__(self):
        self._timestamp = datetime.datetime.now()
        print(f"\n[INFO] {self._timestamp.strftime('%Y-%m-%d %H:%M:%S')} -> scheduler starting...")
    
    def run_queue(self, job_queue):
        cycle = 0
        for job in job_queue:
            print(f"\nnext job in queue: {job}\n")
            print(f"starting execution: pid {job._pid}".center(44, '-'))
            
            job._status = 'active'

            while job._cpucycle > 0:
                cycle += 1
                job._cpucycle -= 1
                print (f"cpu cycle: {cycle}")
                print (job)
            
            print(f"finished execution: pid {job._pid}".center(44, '-') + '\n')
            print(f"changing status: pid {job._pid}".center(44, '-'))
            job._status = 'inactive'
            print(job)
            print(f"removing job: pid {job._pid} from queue".center(44, '-'))

p0 = Job(2, 2, 'inactive')
p1 = Job(3, 3, 'inactive')
p2 = Job(1, 1, 'inactive')
p3 = Job(4, 4, 'inactive')
p4 = Job(5, 5, 'inactive')
jobs = [p0, p1, p2, p3, p4]
schedule = Scheduler()
schedule.run_queue(jobs)
print('\nJobs complete')